From 4e9e9a6d74153b8599518418cab6d2d844399ef4 Mon Sep 17 00:00:00 2001
From: Neal Gompa <ngompa13@gmail.com>
Date: Sun, 13 Mar 2016 14:53:59 -0400
Subject: [PATCH] Initial build target configs for Mageia Cauldron

---
 etc/mock/mageia-cauldron-i586.cfg   | 46 +++++++++++++++++++++++++++++++++++++
 etc/mock/mageia-cauldron-x86_64.cfg | 46 +++++++++++++++++++++++++++++++++++++
 2 files changed, 92 insertions(+)
 create mode 100644 etc/mock/mageia-cauldron-i586.cfg
 create mode 100644 etc/mock/mageia-cauldron-x86_64.cfg

diff --git a/etc/mock/mageia-cauldron-i586.cfg b/etc/mock/mageia-cauldron-i586.cfg
new file mode 100644
index 0000000..cc9af92
--- /dev/null
+++ b/etc/mock/mageia-cauldron-i586.cfg
@@ -0,0 +1,46 @@
+config_opts['root'] = 'mageia-cauldron-i586'
+config_opts['target_arch'] = 'i586'
+config_opts['legal_host_arches'] = ('i386', 'i586', 'i686', 'x86_64')
+config_opts['chroot_setup_cmd'] = 'install basesystem-minimal rpm-build rpm-mageia-setup rpm-mageia-setup-build'
+config_opts['dist'] = 'cauldron'  # only useful for --resultdir variable subst
+config_opts['extra_chroot_dirs'] = [ '/run/lock', ]
+config_opts['useradd'] = '/usr/sbin/useradd -o -m -u %(uid)s -g %(gid)s -d %(home)s %(user)s'
+config_opts['releasever'] = '6'
+config_opts['package_manager'] = 'dnf'
+
+config_opts['yum.conf'] = """
+[main]
+keepcache=1
+debuglevel=2
+reposdir=/dev/null
+logfile=/var/log/yum.log
+retries=20
+obsoletes=1
+gpgcheck=0
+assumeyes=1
+syslog_ident=mock
+syslog_device=
+install_weak_deps=0
+metadata_expire=0
+
+# repos
+
+[mageia-cauldron-core]
+name=Mageia Cauldron - i586
+baseurl=http://mirrors.kernel.org/mageia/distrib/cauldron/i586/media/core/release/
+#metalink=https://mirrors.mageia.org/metalink?repo=cauldron-core-release&arch=i586
+gpgcheck=1
+gpgkey=http://mirrors.kernel.org/mageia/distrib/cauldron/i586/media/core/release/media_info/pubkey
+failovermethod=priority
+enabled=1
+
+[mageia-cauldron-core-debug]
+name=Mageia Cauldron - i586 - Debug
+baseurl=http://mirrors.kernel.org/mageia/distrib/cauldron/i586/media/debug/core/release/
+#metalink=https://mirrors.mageia.org/metalink?repo=cauldron-core-release-debug&arch=i586
+gpgcheck=1
+gpgkey=http://mirrors.kernel.org/mageia/distrib/cauldron/i586/media/debug/core/release/media_info/pubkey
+failovermethod=priority
+enabled=0
+
+"""
diff --git a/etc/mock/mageia-cauldron-x86_64.cfg b/etc/mock/mageia-cauldron-x86_64.cfg
new file mode 100644
index 0000000..8b6f1de
--- /dev/null
+++ b/etc/mock/mageia-cauldron-x86_64.cfg
@@ -0,0 +1,46 @@
+config_opts['root'] = 'mageia-cauldron-x86_64'
+config_opts['target_arch'] = 'x86_64'
+config_opts['legal_host_arches'] = ('x86_64',)
+config_opts['chroot_setup_cmd'] = 'install basesystem-minimal rpm-build rpm-mageia-setup rpm-mageia-setup-build'
+config_opts['dist'] = 'cauldron'  # only useful for --resultdir variable subst
+config_opts['extra_chroot_dirs'] = [ '/run/lock', ]
+config_opts['useradd'] = '/usr/sbin/useradd -o -m -u %(uid)s -g %(gid)s -d %(home)s %(user)s'
+config_opts['releasever'] = '6'
+config_opts['package_manager'] = 'dnf'
+
+config_opts['yum.conf'] = """
+[main]
+keepcache=1
+debuglevel=2
+reposdir=/dev/null
+logfile=/var/log/yum.log
+retries=20
+obsoletes=1
+gpgcheck=0
+assumeyes=1
+syslog_ident=mock
+syslog_device=
+install_weak_deps=0
+metadata_expire=0
+
+# repos
+
+[mageia-cauldron-core]
+name=Mageia Cauldron - x86_64
+baseurl=http://mirrors.kernel.org/mageia/distrib/cauldron/x86_64/media/core/release/
+#metalink=https://mirrors.mageia.org/metalink?repo=cauldron-core-release&arch=x86_64
+gpgcheck=1
+gpgkey=http://mirrors.kernel.org/mageia/distrib/cauldron/x86_64/media/core/release/media_info/pubkey
+failovermethod=priority
+enabled=1
+
+[mageia-cauldron-core-debug]
+name=Mageia Cauldron - x86_64 - Debug
+baseurl=http://mirrors.kernel.org/mageia/distrib/cauldron/x86_64/media/debug/core/release/
+#metalink=https://mirrors.mageia.org/metalink?repo=cauldron-core-release-debug&arch=x86_64
+gpgcheck=1
+gpgkey=http://mirrors.kernel.org/mageia/distrib/cauldron/x86_64/media/debug/core/release/media_info/pubkey
+failovermethod=priority
+enabled=0
+
+"""
-- 
2.5.4 (Apple Git-61)